
//	Copyright 2010 PaletteSoft LLC

// ***************************************************************************
// *	dl															 *
// ***************************************************************************
/*
	_Ci~bNTv@̂P	PIC12F683	CLOCK:INTRCIO/4MHz

	GP0:LED0	Out	0:A1:_
	GP1:LED1	Out	0:A1:_
	GP2:LED2	Out	0:A1:_
	GP3:MCLR	-----
	GP4:SW1		In	0:IA1:It	vAbvp̂	igpj
	GP5:SW0		In	0:IA1:It	vAbvp̂

	LED0	X^eBbNAA_
	LED1	_Ci~bNA|͘A_
	LED2	_Ci~bNA|͘A_

	_Ci~bNF͖RQVUWʂiPURWSʂɐj
					@_䗦͂TO

	SW0		XCb`IŃ^C~OŃ_Ci~bN~AItōĊJ

	荞݂͎gp^C}Õ^CAEg|[OB
*/

// ***************************************************************************
// *	CN[ht@C												 *
// ***************************************************************************

#include	<pic.h>														//	vWFNgݒőIꂽfoCXIɈp܂

#include	<string.h>													//	񑀍n

#include	"_AtrDef.h"													//	萔Af[^^̐錾

// ***************************************************************************
// *	vOo[W												 *
// ***************************************************************************

#define	VER1					0										//	ʏ\̈	PŎwip֎~j
#define	VER2					1										//	ʈ̈	PŎwip֎~j
//								.
#define	VER3					0										//	ʏ\̈	PŎwip֎~j
#define	VER4					0										//	ʈ̈	PŎwip֎~j

#define	COPYRIGHT				"Copyright 2010 PaletteSoft LLC"		//	쌠

// ***************************************************************************
// *																 *
// ***************************************************************************

	//	*****  *****

__CONFIG(	FCMDIS														//	tF[Z[tNbNj^֎~
		&	IESODIS														//	ONbÑXCb`I[o[[h֎~
		&	BORDIS														//	uEAEgo֎~
		&	UNPROTECT													//	f[^iEEPROMj̃veNg֎~
		&	UNPROTECT													//	vÕveNg֎~
		&	MCLREN														//	GP3/_MCLR[q_MCLRŗpiIɃvAbvj
		&	PWRTEN														//	p[Abv^C}싖
		&	WDTDIS														//	EHb`hbO^C}֎~
		&	INTIO														//	NbNpRA4ARA5[q͓o͂ŗp
);

	//	***** hc *****

__IDLOC7(VER1, VER2, VER3, VER4);										//	o[WԍƂĒ`ïӖt͔CӁj

	//	***** U *****

#define	_XTAL_FREQ				4000000									//	gigj		c@__delay_XXňp

// ***************************************************************************
// *	f[^^															 *
// ***************************************************************************

typedef struct {														//	\tgEFAɂovl
	UB		Count;														//	ƗpJE^
	UB		State;														//	ԁiOFItAPFIj
	UB		MasterOn;													//	}X^JE^FIp
	UB		MasterOff;													//	}X^JE^FItp
} sLedPwm;

// ***************************************************************************
// *	Œl																 *
// ***************************************************************************

	//	***** kdc *****

enum {
	LED0,																//	OFkdcO
	LED1,																//	PFkdcP
	LED2,																//	QFkdcQ
	LED_TOTAL															//	RFkdc
};

	//	***** _Ci~bN *****

enum {
	DYN_CYC_2,															//	OF^C}OF	1us *   2 * 256 =   512us	̏𖳎i
	DYN_CYC_4,															//	PF^C}OF	1us *   4 * 256 =  1024us	̏܂Ă
	DYN_CYC_8,															//	QF^C}OF	1us *   8 * 256 =  2048us	ǎ
	DYN_CYC_16,															//	RF^C}OF	1us *  16 * 256 =  4096us	
	DYN_CYC_32,															//	SF^C}OF	1us *  32 * 256 =  8192us	Î~Ă΂
	DYN_CYC_64,															//	TF^C}OF	1us *  64 * 256 = 16384us	
	DYN_CYC_128,														//	UF^C}OF	1us * 128 * 256 = 32768us	
	DYN_CYC_256															//	VF^C}OF	1us * 256 * 256 = 65536us	
};

#define	DYN_CYC					(DYN_CYC_64)							//	Iꂽ		@CƁuvPł܂

// ***************************************************************************
// *	O[oϐ														 *
// ***************************************************************************

union {
	UB	BYTE;															//	oCgANZXp
	struct {
		UINT	Led0	: 1;											//	kdcO
		UINT	Led1	: 1;											//	kdcP
		UINT	Led2	: 1;											//	kdcQ
		UINT	Dummy	: 5;											//	_~[
	} BIT;
} vPortData;															//	o̓|[g̃obNAbv

UB		vLedCtrl;														//	_Ci~bNǗ

// ***************************************************************************
// *	e[u															 *
// ***************************************************************************


// ***************************************************************************
// *	}N錾															 *
// ***************************************************************************

	//	***** kdc *****

#define	mLed0_On()				vPortData.BIT.Led0 = 1					//	kdcO_
#define	mLed1_On()				vPortData.BIT.Led1 = 1					//	kdcP_
#define	mLed2_On()				vPortData.BIT.Led2 = 1					//	kdcQ_

#define	mLed0_Off()				vPortData.BIT.Led0 = 0					//	kdcO
#define	mLed1_Off()				vPortData.BIT.Led1 = 0					//	kdcP
#define	mLed2_Off()				vPortData.BIT.Led2 = 0					//	kdcQ

	//	***** XCb` *****

#define	misSw0_On()			(GPIO5 == 0)								//	rvOIffp
#define	misSw0_Off()		(GPIO5 != 0)								//	rvOItffp

// ***************************************************************************
// *	vg^Cv錾													 *
// ***************************************************************************

	//	***** }lWg *****

void	main(void);

	//	***** foCX *****

void	DevInit(void);

	//	***** ^C} *****

void	TmInit(void);
void	TmWait(void);

// ***************************************************************************
// *	{															 *
// ***************************************************************************

//	
//	
//
// 		}lWg
//
//	
//	
void	Mng______(void) {}												//	op֐

//============================================================================
//	C
//----------------------------------------------------------------------------
//	́F	
//	óF	
//----------------------------------------------------------------------------
//	lF	X^[gAbv[`̃Wv߂ŌĂяo܂B
//			{֐͖[vłAEo邱Ƃ͂܂B
//============================================================================
void	main(void)
{
	//	***** ͂߂ *****

	di();																//	Ă̊荞݋֎~𖾎

	DevInit();															//	foCXݒ
	TmInit();															//	^C}ݒ				c@Ȍ͂PURWSʂŃ^CAEg

	mLed0_On();															//	kdcO_				c@X^eBbNɂȂ܂
	vLedCtrl = 0;														//	ǗNA			c@̏ꍇ͕słB܂@Ƃ

	//	*****  *****

	while (1) {															//	[vł

		//	***** Ƃkdc\XV *****

		TmWait();														//	^C}̃^CAEgҋ@	c@̊֐͏ɐ̐擪ɂȂ

		GPIO = vPortData.BYTE;											//	ێf[^ňꊇXV		c@ŖXV

		//	***** _Ci~bN *****

		if (misSw0_Off()) {												//	XCb`̓ItH			c@ȈՕ]pȂ̂Ń`^O͍s܂

			if (vLedCtrl & 0x01) {										//	rbgO͂PH

				//	***** kdcQ@@kdc1 *****

				mLed1_On();												//	kdcPFI
				mLed2_Off();											//	kdcQFIt
			}
			else {														//	rbgO͂O

				//	***** kdcP@@kdcQ *****

				mLed1_Off();											//	kdcPFIt
				mLed2_On();												//	kdcQFI
			}

			vLedCtrl ++;												//	P{P					c@kraԂɐ؂ւ΂nj
		}
		else {															//	XCb`̓I
			;															//	\ʒu͍XV܂
		}

		//	***** ̑̏ *****

		;																//	͓ɂ܂Bɂł zzz

	}
}

//	
//	
//
// 		foCX
//
//	
//	
void	Dev______(void) {}												//	op֐

//============================================================================
//	foCXݒ
//----------------------------------------------------------------------------
//	́F	
//	óF	
//----------------------------------------------------------------------------
//	lF	foCX̏ݒs܂B
//			Zbg̏lōςޏꍇ͍Đݒ肵Ă܂B
//============================================================================
void	DevInit(void)
{
	//	***** { *****

//						  76543210
	OPTION =			0b01111111;										//	IvVWX^
																		//	bit07:GPPU		0	̓|[g̃vAbv			
																		//	bit06:INTEDG	1	O荞݂͗オGbW		gp
																		//	bit05:T0CS		1	^C}O͊ONbN𗘗p		gp
																		//	bit04:T0SE		1	^C}O̍XV͗GbW		gp
																		//	bit03:PSA		1	vXP[͂vcsŗp			gp
																		//	bit02:PS2		1	vXP[͂PQW			gp
																		//	bit01:PS1		1		ij
																		//	bit00:PS0		1		ij

	//	***** o̓|[g *****										//	ӁFĂ̏ꍇAėpo̓|[g͕ʋ@\Ă

//						  76543210
	vPortData.BYTE =	0b00000000;										//	ėpo̓|[gf[^̏l
																		//	bit07:-----		0
																		//	bit06:-----		0
																		//	bit05:GP5		0	́FrvO						͂Ȃ̂ŖӖ
																		//	bit04:GP4		0	́FrvP						͂Ȃ̂ŖӖ
																		//	bit03:GP3		0	́Flbkq						w͖
																		//	bit02:GP2		0	óFkdcQ						
																		//	bit01:GP1		0	óFkdcP						
																		//	bit00:GP0		0	óFkdcO						

	GPIO = vPortData.BYTE;												//	o̓|[gꊇҏW	c@rbgɂRead&ModifysȂ@

//						  76543210
	CMCON0 =			0b00000111;										//	Rp[^
																		//	bit07:-----		0
																		//	bit06:COUT		0	Rp[^o͏				ǂݏô݉
																		//	bit05:-----		0
																		//	bit04:CINV		0	o͔]Ȃ						gp
																		//	bit03:CIS		0	̓XCb`ݒ					gp
																		//	bit02:CM2		1	Rp[^It					
																		//	bit01:CM1		1		ij						
																		//	bit00:CM0		1		ij						

//						  76543210
	ANSEL =				0b00000000;										//	AiOZN^
																		//	bit07:-----		0
																		//	bit06:ADCS2		0	`cϊNbNI				gp
																		//	bit05:ADCS1		0		ij
																		//	bit04:ADCS0		0		ij
																		//	bit03:ANS3		0	`mRgpAfoSėpo		
																		//	bit02:ANS2		0	`mQgpAfoQėpo		
																		//	bit01:ANS1		0	`mPgpAfoPėpo		
																		//	bit00:ANS0		0	`mOgpAfoOėpo		

//						  76543210
	TRISIO =			0b00111000;										//	ėpo̓|[g
																		//	bit07:-----		0
																		//	bit06:-----		0
																		//	bit05:GP5		1	́FrvO						
																		//	bit04:GP4		1	́FrvP						
																		//	bit03:GP3		1	́Flbkq						ǂݏô݉
																		//	bit02:GP2		0	óFkdcQ						
																		//	bit01:GP1		0	óFkdcP						
																		//	bit00:GP0		0	óFkdcO						
}

//	
//	
//
// 		^C}
//
//	
//	
void	Tm______(void) {}												//	op֐

//============================================================================
//	ݒ
//----------------------------------------------------------------------------
//	́F	
//	óF	
//----------------------------------------------------------------------------
//	lF	^C}Ȍݒs܂B
//			^CAEg͂PURWSʂłB
//============================================================================
void	TmInit(void)
{
	//	***** ^C}Õ[hݒ *****

	CLRWDT();															//	vcs̃tbV	c@ʓIɓ삵ĂȂ̂Ōʖ
																		//								f[^V[gɋLڂĂ@𓥏P
//						 76543210	   76543210
	OPTION = (OPTION & 0b11010000) | 0b00000000 | (DYN_CYC);			//	IvVWX^		c@ݒς݂̒lC
																		//	bit07:GPPU		*	iύXȂj
																		//	bit06:INTEDG	*	iύXȂj
																		//	bit05:T0CS		0	^C}O͓NbN𗘗p		
																		//	bit04:T0SE		*	iύXȂj
																		//	bit03:PSA		0	vXP[̓^C}Oŗp		
																		//	bit02:PS2		?	vXP[́HH				
																		//	bit01:PS1		?		ij
																		//	bit00:PS0		?		ij

	/*
		DYN_CYC̒lɂ萧ς܂B
		錾͂PPOsڂ́uŒlv̉ӏQƂĂ
	*/

	//	***** ^C}Õ^CAEg󋵂 *****

	TMR0 = 0;															//	^C}OJE^̃NAivXP[ɃNAj
	T0IE = 0;															//	^C}O͋֎~
	T0IF = 0;															//	^C}Ov	c@slqOWX^̃I[o[t[
}

//============================================================================
//	^CAEgҋ@
//----------------------------------------------------------------------------
//	́F	
//	óF	
//----------------------------------------------------------------------------
//	lF	^C}Õ^CAEgiPURWSʂjҋ@܂B
//			O̊֐sォÅ֐s̊Ԋu͈łB
//============================================================================
void	TmWait(void)
{
	while (T0IF == 0)	;												//	^C}O荞ݗv܂őҋ@
	T0IF = 0;															//	^C}Ov
}

// ***************************************************************************
// ***************************************************************************
// *																		 *
// ***************************************************************************
// ***************************************************************************

//	Copyright 2010 PaletteSoft LLC

